=== debian/changelog ===
sdrangel (7.7.0-1) unstable; urgency=medium

  * Remote control feature plugin. PR #1414
  * Stop status timer, so updateTimer isn't called on deleted objects. PR #1408
  * APRS feature: Detect Packet Demods in MIMO device sets. Fixes #1409. PR #1410
  * Fixed some cmake warnings. PR #1411 #1412
  * Replace deprecated QMutex(Recursive) in Qt 5.14 with QRecursiveMutex. PR #1413
  * Upgrade Ubuntu package to 22.04 and therefore Qt 5.15. Issue #1416

  -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Sun, 18 Sep 2022 08:48:24 +0200

sdrangel (7.6.4-1) unstable; urgency=medium

  * M17: fixed build for Windows so now available in Windows. PR #1404
  * Use grey text for disabled widgets. PR #1402
  * Stack workspace: Use full width for spectrum when no channels. PR #1403
  * Fix c++17 compilation with MSVC. PR #1405

  -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Sat, 10 Sep 2022 19:12:31 +0200

sdrangel (7.6.3-1) unstable; urgency=medium

  * NFM modulator: try to improve audio input
  * Simple PTT: fixed status indicator
  * LimeRFE feature: fixed settings API
  * ScriptsAPI: fixed dump.py and config.py to match v7 requirements
  * ScriptsAPI: removed obsolete config.py -I option
  * ScriptsAPI: new ptt_feature.py based on PTT amd LimeRFE features
  * LimeSDR: reduced LimeSDR stream FIFO size to 256k to improve latency
  * LimeSDR: better handle calibration errors. Fix #1389. PR #1391
  * LimeSDR: Set Lime minimum frequency in GUI to 30MHz+NCO freq. Fix #1389. PR #1391
  * LimeSDR: Set minimum calibration bandwidth to 2.5MHz. Fix #1389. PR #1391
  * LimeSDR: Report calibration errors in GUI. Fix #1389. PR #1395
  * LimeSDR: Check LPF is reasonable for up/downconversion. Fix #1389. PR #1395
  * ADS-B: Add support for decoding Comm-B replies in Mode-S frames. PR #1393
  * ADS-B: Check ICAO in sink worker, so CRC can be checked. Fix warnings. PR #1393
  * Add start/stop all devices of workspace button in workspace toolbar. PR #1394
  * Add device stateChanged signal. Use in RTL SDR GUI. PR #1394
  * Remove ? in Window's title bar. Fixes #1312. PR #1399

  -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Thu, 01 Sep 2022 19:46:21 +0200

sdrangel (7.6.2-1) unstable; urgency=medium

  * MacOS build fixes. PR #1374
  * ChannelAnalyzer: apply fix for #892 only if the current trace mode is live. Fixes #1375
  * Call find_package for OpenCV on Windows for modatv. PR #1382. Fixes #1366
  * M17 mod: removed unwanted method declaration. Fixes #1380
  * RemoteTCPInput: Use input frequency offset when calculating local centre frequency. PR #1383. Fixes #1377
  * WFM mod: fixed bug in WFMGUI::applySettings. Fixes #1387
  * SimplePTT: fixed list of audio devices for VOX displaying output instead of input devices
  * Removed stray comma in CmakeLists.txt. Complements #1310. Fixes #1388

  -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Sun, 14 Aug 2022 09:49:13 +0200

sdrangel (7.6.1-1) unstable; urgency=medium

  * Fix map feature 5.15.4 check. PR #1370
  * M17 library some code rework
  * DATV demod: allocate DATVDemodSink dynamically
  * New threading model for some plugins
  * DSD demod GUI: fixes for non existent AMBE feature. Fixes #1334
  * Corrected order of deletion of feature vs feature GUI. Fixes #1332
  * Some OpenGL fixes. Issues #1351 #1359. PR #1361

  -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Wed, 03 Aug 2022 16:46:27 +02004

sdrangel (7.6.0-1) unstable; urgency=medium

  * Remote TCP Input and Remote TCP Sink Plugins. Issue #456. PR #1350
  * SDRPlayInput: upgrade libmirisdr-4 version to 2.0.0. PR #1344
  * DATV Demod: Add support for LDPC on Windows. Issue #1342. PR #1345
  * Externals: Update rtlsdr to latest version. Issue #1351. PR #1352
  * Map: Add support for Ionosonde stations. PR #1354

  -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Wed, 20 Jul 2022 19:53:15 +0200

sdrangel (7.5.1-1) unstable; urgency=medium

  * M17 is for Linux only

  -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Mon, 18 Jul 2022 13:22:31 +0200

sdrangel (7.5.0-1) unstable; urgency=medium

  * M17 mode implementation (mod and demod plugins). Issue #1259
  * AIS: NMEA sentences must end with CR/LF. Issue #1333. PR #1342
  * Darken ValueDials when disabled. PR #1331
  * Map: Fix capitalisation of Radiosonde so settings are found. Fixes #1318. PR #1320
  * USRP: Catch all exceptions from set_rx_agc. PR #1315
  * GLScope and GLSpectrum removed extraneous call to cleanup method. Fixes #1295
  * Update to sdrangel-windows-libraries with UHD 4.2.0. PR #1314

  -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Mon, 18 Jul 2022 09:36:28 +0200

sdrangel (7.4.0-1) unstable; urgency=medium

  * 3D Spectrogram and OpenGL code fixes. PR #1291
  * USRP: fixed possible KeyError exception. Fixes #1284. PR #1288
  * Add support for Broadcast FM Demod audio in Demod Analyzer. PR #1292
  * Spectrum: Prevent null texture warning when only histogram is displayed. PR #1294
  * 3D Spectrogram: Fixes #1297. PR #1298
  * External libraries: removed unnecessary SerialDV dependency to fix MSVC builds
  * Spectrum: And fill and gradient styles. PR #1299
  * Allow 2D waterfall color map to be changed. PR #1299
  * Change frequency zoom so that frequency under cursor remains the same. PR #1300
  * Spectrum markers dialog: Fix show field in CSV export. PR #1301
  * Value dial: Check for completed animation before using m_value. PR #1303
  * Reworked spectrum GUI controls
  * Spectrum: Fix mouse wheel to zoom in waterfall. PR #1304
  * Spectrum: Allow frequency scolling with mouse. PR #1305
  * Spectrum markers: Allow all to be displayed. PR #1306
  * SpectrumGUI: Go to combo to set center frequency from annotation marker. PR #1309
  * Added minimal default cmake preset
  * Added cmake enablers for all non sampling device plugins. Fixes #1308

  -- Edouard Griffiths, F4EXB  <f4exb06@gmail.com>  Sun, 26 Jun 2022 04:25:21 +0200

sdrangel (7.3.2-1) unstable; urgency=medium

  * Use libusb 1.0.26 on Windows

